
               INCLUDE    flp1_macro_lib
               INCLUDE    flp1_pipe_definitions

*************************** actual code **************************************


               XDEF      link.nul


               SECTION   text

link.nul
               lea.l     link,a0              ; start of linkage block (p 140)
               lea.l     io.doit,a1
               lea.l     nul.io,a2
               move.l    a1,(a2)+
               lea.l     open,a1
               move.l    a1,(a2)+
               lea.l     close,a1
               move.l    a1,(a2)+
               moveq     #mt.liod,d0
               trap      #1
               rts

open           bra.s     op.echt             ; jump to start of code 
nul.name       dc.w      3                   ; header for e.g. QRAM/QPAC
               dc.b      'NUL'
               dc.w      0
op.echt        movem.l   d3/a0/a3/a6,-(a7)
               lea.l     nul.name,a1          
               sub.l     a6,a0      
               sub.l     a6,a1      
               moveq     #ignore.case,d0     ; let niet op details
               vector    ut.cstr   a3
               tst.l     d0                  ; zijn namen gelijk?
               beq.s     hebbes
               move.l    #err.nf,d0
               bra.s     op.mis

hebbes         moveq     #ch.end,d1
               vector    mm.alchp  a1
               tst.l     d0
               bne.s     op.mis
               move.l    d1,ch.len(a0)
               movem.l   (a7)+,d3/a1/a3/a6
               rts

op.mis         movem.l   (a7)+,d3/a0/a3/a6
               rts


close          
               vector     mm.rechp  a1
               rts


io.doit        cmp.l     #5,d0
               blt.s     io.eof
               cmp.l     #7,d0
               bgt.s     badparm
               move.w    d2,d1
               lea.l     0(a1,d1.w),a1
               clr.l     d0
               rts
badparm        moveq     #err.bp,d0
               rts
io.eof         moveq     #err.eof,d0
               rts

          SECTION   data


link          dc.l 0          ; this block of 4 longwords is linked into ..
nul.io        ds.l 1          ; .. the device driver list     
nul.open      ds.l 1
nul.close     ds.l 1               


     END
